<?php

namespace app\controllers\mikrotik\interfaces;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\MikrotikSideMenu;
use app\models\mikrotik\interfaces\Vrrp;
use app\models\mikrotik\Interfaces;

class VrrpController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_interfacesCreateVrrp'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_interfacesDeleteVrrp'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_interfacesDisableVrrp'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_interfacesEnableVrrp'],
                    ],
                     [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_interfacesUpdateVrrp'],
                    ],

                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $menu = new MikrotikSideMenu();
        $model = new Vrrp();
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Vrrp();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/interfaces/interfaces/index'));
            }
        } else {
            $model->get($id);
        }
        $inter = new Interfaces();
        $et = $inter->getNames();
        foreach ($et as $value) {
            $eth[$value] = $value;
        }
        return $this->render('/mikrotik/interfaces/vrrp', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'eth' => $eth,
                    'action' => 'update',
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Vrrp();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/interfaces/interfaces/index'));
            }
        }
        $inter = new Interfaces();
        $et = $inter->getNames();
        foreach ($et as $value) {
            $eth[$value] = $value;
        }
        return $this->render('/mikrotik/interfaces/vrrp', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'eth' => $eth,
                    'action' => 'create',
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Vrrp();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/interfaces/interfaces/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Vrrp();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/interfaces/interfaces/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Vrrp();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/interfaces/interfaces/index'));
    }

}
